#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use htbuild;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "add_include") {&add_include;}
if ($q->param('fct') eq "add_include_final") {&add_include_final;}
if ($q->param('fct') eq "edit") {&edit_include;}
if ($q->param('fct') eq "edit_save") {&edit_save;}
if ($q->param('fct') eq "delete") {&delete_include;}
if ($q->param('fct') eq "get_html") {&get_html;}
if ($q->param('fct') eq "preview") {&preview_incl;}

####################################################################################

sub preview_incl
{

$iname = $q->param('iname');

$incls = acs::get_file_contents("$data_dir/tmpl_inc.dat"); 
@all_inc = split (/\n/, $incls);

$cnt = 0;
foreach $item (@all_inc)
	{
	($i_iname, $i_itype, $i_cid, $i_isort, $i_nr, $prem) = split (/\t/, $item);
	
	if ($i_iname eq $iname)
		{
		$real_itype = $i_itype;
		$real_cid = $i_cid;
		$real_isort = $i_isort;
		$real_nr = $i_nr;
		$real_prem = $prem;
		}

	}

###########


$popcrit = $iname . ":" . $real_cid . ":" . $real_isort . ":" . $real_nr . ":" . $real_itype . ":" . $real_prem;
			
($linki, $pop_cpages, $pop_curpage, $pop_lnks_processed) = htbuild::get_cat("", "", "STATIC", "", "", "include", $popcrit);

print "$linki";

}






sub get_html
{

$iname = $q->param('iname');

#####

$incls = acs::get_file_contents("$data_dir/tmpl_inc.dat"); 
@all_inc = split (/\n/, $incls);

$cnt = 0;
foreach $item (@all_inc)
	{
	($i_iname, $i_itype, $i_cid, $i_isort, $i_nr, $prem) = split (/\t/, $item);
	
	if ($i_iname eq $iname)
		{
		$real_itype = $i_itype;
		$real_cid = $i_cid;
		$real_isort = $i_isort;
		$real_nr = $i_nr;
		$real_prem = $prem;
		}

	}

###########

$popcrit = $iname . ":" . $real_cid . ":" . $real_isort . ":" . $real_nr . ":" . $real_itype . ":" . $real_prem;
			
($linki, $pop_cpages, $pop_curpage, $pop_lnks_processed) = htbuild::get_cat("", "", "STATIC", "", "", "include", $popcrit);

$linki =~ s/\n/ /g;
$crit = chr(10); $linki =~ s/$crit/ /g;
$crit = chr(13); $linki =~ s/$crit/ /g;
$linki =~ s/'/\\'/g;

open (WINCL, "> $web_dir/$iname.js");
	print WINCL "function get_$iname()\n";
	print WINCL "{\n";
	print WINCL "document.write ('$linki');\n";
	print WINCL "}\n";
close (WINCL);
chmod($default_permissions,"$web_dir/$iname.js","$web_dir/$iname.js");


#####

$head_script = "<script SRC=\"$web_url/$iname.js\"></script>";

$body_script = <<END_OF_BSCRIPT;
<script LANGUAGE="JavaScript" TYPE="text/javascript">
<!--
get_$iname();
// -->
</script>
END_OF_BSCRIPT



$hbox = acs::get_heading_box("$web_url/ic_pop2.gif", "Generate Include & Get Include HTML Code", qq[
Copy and paste the HTML code below into your web pages or PowerSeek templates.<BR>
<b><a href="$admin_url/admin45.cgi">Go Back</a></b>
]);


print <<END_OF_HTMLC;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox



<blockquote>
  <p class="normaltext"><strong>The include was created and placed in: <br>
  </strong>$web_dir/$iname.js <strong><br>
  or <br>
  </strong>$web_url/$iname.js </p>
</blockquote>

<hr noshade size="1" color="#F2F2F2">

<p class="normaltext">Include Name:<strong> $iname </strong></p>

<p class="normaltext"><strong>Note that the includes are generated just like HTML files. </strong>This means
that the includes will be automatically updated/generated when you generate your HTML
files. </p>

<table border="0" cellpadding="6" width="100%" style="border: 1px solid rgb(218,218,218)"
cellspacing="1">
  <tr>
    <td width="101%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>HTML CODE:</strong></td>
  </tr>
  <tr>
    <td width="101%" valign="top"><span class="normaltext">Below is HTML Code or JavaScript code which you can place
    inside existing web pages or templates of PowerSeek. </span>
      <form method="POST"
    action="--WEBBOT-SELF--">
      <span class="normaltext">
<!--webbot bot="SaveResults" startspan U-File="_private/form_results.txt"
      S-Format="TEXT/CSV" S-Label-Fields="TRUE" -->
<!--webbot bot="SaveResults" endspan -->
      </span>
      <p class="normaltext"><strong>Place
      the following between the body tags of web pages or PowerSeek templates. You can place
      this code any where inside the body tags where you would like the link includes to be
      displayed. </strong></p>
      <p class="normaltext">
        <textarea rows="10" name="S2" cols="46" style="width:100%">$head_script
$body_script</textarea>
      </p>
    </form>    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" class="normaltext"><font color="#FFFFFF">_</font> </td>
    <td width="99%"></td>
  </tr>
</table>

<p class="normaltext"><a href="$admin_url/admin45.cgi"><strong>Go Back </strong></a></p>

</body>
</html>

END_OF_HTMLC


}


sub delete_include
{

$iname = $q->param('iname');

$incls = acs::get_file_contents("$data_dir/tmpl_inc.dat"); 
@all_inc = split (/\n/, $incls);

$cnt = 0;
foreach $item (@all_inc)
	{
	($i_iname, $i_itype, $i_cid, $i_isort) = split (/\t/, $item);
	
	if ($i_iname ne $iname)
		{
		$tw_incl = $tw_incl . $item . "\n";
		}

	}

### WRITE FILE
open (DTA, "> $data_dir/tmpl_inc.dat");
	print DTA $tw_incl;
close (DTA);

$tfn = "hpinc_" . $iname . ".html";
unlink ("$data_dir/$tfn");

$hbox = acs::get_heading_box("$web_url/ic_pop2.gif", "Link Include Deleted", qq[
<a href="$admin_url/admin45.cgi">Click Here to Continue.</a>
]);


print <<END_OF_ED;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>


END_OF_ED



}






sub edit_save
{

$iname = $q->param('iname');
$itype = $q->param('itype');
$cid = $q->param('crosslinkid');
$sort = $q->param('sort');
$template = $q->param('template');
$inumber = $q->param('inumber');
$iprem = $q->param('prem');


if ($q->param('iname') eq "")
	{
	acs::problem_popup("You have to supply an include name for the include you are about to create."); 
	}

if ($q->param('crosslinkid') eq "")
	{
	acs::problem_popup("You have to supply a category ID."); 
	}

if ($q->param('template') eq "")
	{
	acs::problem_popup("You have to have template HTML code for the link displays."); 
	}

if ($q->param('inumber') eq "")
	{
	acs::problem_popup("You have to have to supply the number of links to be displayed."); 
	}

#### CHECK IF CATEGORY EXISTS

if ($q->param('crosslinkid') != 0)
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT cid FROM dirs WHERE cid = '$cid'";
$sth = $dbh->prepare($sql); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("The category ID you supplied was not recognized as a valid category."); }

$sth->finish;
$dbh->disconnect; 

}

### SAVE

$incls = acs::get_file_contents("$data_dir/tmpl_inc.dat"); 
@all_inc = split (/\n/, $incls);

$cnt = 0;
foreach $item (@all_inc)
	{
	($i_iname, $i_itype, $i_cid, $i_isort, $i_inumber) = split (/\t/, $item);
	
	if ($i_iname eq $iname)
		{
		$tw_incl = $tw_incl . $iname . "\t" . 
							  		 $itype . "\t" .
							  		 $cid . "\t" .
								    $sort . "\t" . 
								    $inumber . "\t" . 
								    $iprem . "\n";
		}			
		else
		{
		$tw_incl = $tw_incl . $item . "\n";
		}

	}


### WRITE FILE
open (DTA, "> $data_dir/tmpl_inc.dat");
	print DTA $tw_incl;
close (DTA);


### WRITE TEMPLATE
$tfn = "hpinc_" . $iname . ".html";
open (TMPLF, "> $data_dir/$tfn");
	print TMPLF $template;
close (TMPLF);


$hbox = acs::get_heading_box("$web_url/ic_pop2.gif", "Link Include Saved", qq[
<a href="$admin_url/admin45.cgi">Click Here to Continue.</a>
]);


print <<END_OF_ED;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

END_OF_ED

}






sub edit_include
{

$iname = $q->param('iname');

$incls = acs::get_file_contents("$data_dir/tmpl_inc.dat"); 
@all_inc = split (/\n/, $incls);

foreach $item (@all_inc)
	{
	($i_iname, $i_itype, $i_cid, $i_isort, $inumber, $iprem) = split (/\t/, $item);
	
	if ($i_iname eq $iname)
		{
		$real_iname = $iname;
		
		$real_icid = $i_cid;
		
		$real_prem = $iprem;
		
		if ($i_itype eq "New")
			{
			$i_itype_new = "selected";
			}
			else
			{
			$i_itype_pop = "selected";
			}
		
		if ($i_isort eq "vote")
			{
			$i_isort_vote = "selected";
			}
			else
			{
			$i_isort_click = "selected";
			}
		
		$realinumber = $inumber;
		}
	}


### GET CATEGORY NAME

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT * FROM dirs WHERE cid = '$real_icid'";
$sth = $dbh->prepare($sql); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$cnt = 0;
while ( @row = $sth->fetchrow() )
	{ 
	$ecat = "";
	$lv = 0;
	for ($ms = 2; $ms < 18; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$ecat = $ecat . $row[$ms] . "/";
			}
		}
	} 

$sth->finish;
$dbh->disconnect; 

$tfn = "hpinc_" . $iname . ".html";

$template = acs::get_file_contents("$data_dir/$tfn"); 



if ($real_prem eq "Y") { $premchecked = "checked"; }

#####################

$hbox = acs::get_heading_box("$web_url/ic_pop2.gif", "Edit Link Include", qq[
<b><a href="$admin_url/admin45.cgi">Go Back</a></b>
]);


$helpb = acs::quick_help("Help",qq[<p>Let's say that you would like to display the most popular or new links from a main
category called 'Business' for example. To list the most popular links on an external web
page or in any PowerSeek templates, create a <strong>Link Include </strong>and copy and
paste the HTML code for it into an external Web Page or PowerSeek template. Once the code
is in the web page or template the most popular links from the Business category will be
displayed on the web page or in the PowerSeek template. Note that for Link Includes to be
displayed you will have to rebuild your HTML files because the new and popular link
includes are generated when generating HTML files. </p>
]);



print <<END_OF_INCL;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(400,0);
      myWindow.focus();

    }
 // End Hide -->
 </script>

</head>
<body>

$hbox


<form method="POST" action="$admin_url/admin45.cgi" name="addu">
  <input type="hidden" name="fct" value="edit_save"><input type="hidden" name="iname"
  value="$iname"><table border="0" cellspacing="1" width="100%" cellpadding="6"
  bgcolor="#DADADA">
    <tr>
      <td height="30" colspan="2" background="$web_url/bar6.gif" class="normaltext" width="1014"><strong>Edit
      Link Include: </strong></td>
    </tr>
    <tr>
      <td width="158" bgcolor="#FFFFFF" class="normaltext"><strong>Include Name: </strong></td>
      <td width="842" bgcolor="#FFFFFF" class="normaltext">$real_iname </td>
    </tr>
    <tr>
      <td width="158" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Include Type: </strong></td>
      <td width="842" bgcolor="#FFFFFF" class="normaltext"><select name="itype" size="1">
        <option $i_itype_new value="New"> New </option>
        <option $i_itype_pop value="Popular"> Popular </option>
      </select> <br>
      <strong>&nbsp;&nbsp; <br>
      New: </strong>List new links <br>
      <strong>Popular: </strong>List links with the most clicks </td>
    </tr>
    <tr>
      <td width="158" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Links
      Only:</strong></td>
      <td width="842" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="prem"
      value="Y" $premchecked>(If this is checked then only 'premium' new or 'premium' popular links
      will be included)</td>
    </tr>
    <tr>
      <td width="158" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Category ID: </strong></td>
      <td width="842" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="crosslinkid"
      size="5" value="$real_icid"> <strong>(<a href="$admin_url/admin67.cgi"
      onClick="popup('$admin_url/admin67.cgi',750,600);return false;">Browser</a>)</strong><br>
      Please specify a category ID above. Click the 'Browser' link to find a category.<br>
      Use <strong>0</strong> if you want to compile popular or new links from all categories. <br>
      <br>
      <b>/$ecat </b></td>
    </tr>
    <tr>
      <td width="158" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Popularity: </strong></td>
      <td width="842" bgcolor="#FFFFFF" class="normaltext"><select name="sort" size="1">
        <option $i_isort_vote value="vote"> Most Voted </option>
        <option $i_isort_click value="click"> Most Clicked </option>
      </select> <br>
      &nbsp;&nbsp; <br>
      <strong>Most voted: </strong>Display links with the most votes <br>
      <strong>Most Clicked: </strong>Display links with the most clicks <p>This setting is only
      valid if this include will display popular links. </td>
    </tr>
    <tr>
      <td width="158" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number of Links:
      </strong></td>
      <td width="842" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="inumber"
      size="5" value="$realinumber"> <br>
      The number of popular or new links to be displayed. </td>
    </tr>
    <tr>
      <td width="158" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Link Template: </strong></td>
      <td bgcolor="#FFFFFF" class="normaltext" width="842"><textarea rows="16" name="template"
      cols="75">$template</textarea> <br>
      <a href="$admin_url/admin6.cgi?template=tmplsearch&amp;fct=tinfo&amp;includes=1"
      target="_blank">Click here </a>to see what PowerSeek variables can be used. This template
      represents the style of the inks that will be displayed in the include. It functions in
      the same way the PowerSeek link style template does. (tmplsearch.html) </td>
    </tr>
    <tr>
      <td bgcolor="#FFFFFF" width="158" valign="top"></td>
      <td bgcolor="#FFFFFF" width="842"><input type="submit" value="   Save Link Include   "
      name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
  <p>$helpb </p>
</form>


</body>
</html>

END_OF_INCL


}






sub add_include_final
{
$isort = $q->param('sort');
$iname = $q->param('iname');
$itype = $q->param('itype');
$cid = $q->param('crosslinkid');
$template = $q->param('template');
$inumber = $q->param('inumber');
$prem = $q->param('prem');

for ($ms = 0; $ms < length($q->param('iname')); $ms++) 
	{
	$oneletter = substr($q->param('iname'), $ms, 1);
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne "_"))
		{
		acs::problem_popup("The include name you specified contains invalid characters. Please use only numerical characters or characters present in the english alphabet.");
		}
	} 

if ($q->param('iname') eq "")
	{
	acs::problem_popup("You have to supply an include name for the include you are about to create."); 
	}

if ($q->param('inumber') eq "")
	{
	acs::problem_popup("You have to supply a number to indicate the number of links to display"); 
	}


if ($q->param('crosslinkid') eq "")
	{
	acs::problem_popup("You have to supply a category ID."); 
	}

if ($q->param('template') eq "")
	{
	acs::problem_popup("You have to have template HTML code for the link displays."); 
	}



#### CHECK IF CATEGORY EXISTS
if ($q->param('crosslinkid') != 0)
{
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT cid FROM dirs WHERE cid = '$cid'";
$sth = $dbh->prepare($sql); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

if ($rows < 1) { acs::problem_popup("The category ID you supplied was not recognized as a valid category."); }

$sth->finish;
$dbh->disconnect; 
}


#### CHECK FOR DUPLICATES

$incls = acs::get_file_contents("$data_dir/tmpl_inc.dat"); 
@all_inc = split (/\n/, $incls);

foreach $item (@all_inc)
	{
	($i_iname, $i_itype, $i_cid, $i_isort) = split (/\t/, $item);
	if ($i_iname eq $iname) { acs::problem_popup("The include name you are trying to use is already in use."); }
	}



##############################

open (TPLI, ">> $data_dir/tmpl_inc.dat");
	print TPLI		$iname . "\t" . 		### NAME
						$itype . "\t" . 		### INCLUDE TYPE
						$cid . "\t" . 	 		### CATEGORY ID
						$isort . "\t" .		### SORTED BY
						$inumber . "\t" .		### SORTED BY
						$prem . "\n";			### PREMIUM LINKS ONLY
close (TPLI);

chmod($default_permissions,"$data_dir/tmpl_inc.dat","$data_dir/tmpl_inc.dat");

$tmplname = "hpinc_" . $iname . ".html";

open (TPLI, "> $data_dir/$tmplname");
	print TPLI $template;
close (TPLI);

chmod($default_permissions,"$data_dir/$iname.pni","$data_dir/$iname.pni");


##############################

$hbox = acs::get_heading_box("$web_url/ic_pop2.gif", "Include Created", qq[
<a href="$admin_url/admin45.cgi">Click Here to Continue.</a>
]);


print <<END_OF_ADDED;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

END_OF_ADDED

}






sub add_include
{


$hbox = acs::get_heading_box("$web_url/ic_pop2.gif", "Add a Popular or New Link Include", qq[
<b><a href="$admin_url/admin45.cgi">Go Back</a></b>
]);



$helpb = acs::quick_help("Help",qq[<p>Let's say that you would like to display the most popular or new links from a main
category called 'Business' for example. To list the most popular links on an external web
page or in any PowerSeek templates, create a <strong>Link Include </strong>and copy and
paste the HTML code for it into an external Web Page or PowerSeek template. Once the code
is in the web page or template the most popular links from the Business category will be
displayed on the web page or in the PowerSeek template. Note that for Link Includes to be
displayed you will have to rebuild your HTML files because the new and popular link
includes are generated when generating HTML files. </p>
]);


$linkstyle = acs::get_file_contents("$data_dir/tmplsearch.html");


print <<END_OF_ADD_I;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);
    var myspecs = "'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=" + mywidth + ",height=" + myheight + "'";
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(400,0);
      myWindow.focus();

    }
 // End Hide -->
 </script>

</head>
<body>

$hbox



<form method="POST" action="$admin_url/admin45.cgi" name="addu">
  <input type="hidden" name="fct" value="add_include_final"><table border="0"
  cellspacing="1" width="100%" cellpadding="6" bgcolor="#DADADA">
    <tr>
      <td width="781" height="30" colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>Add
      a Popular or New Link Include </strong></td>
    </tr>
    <tr>
      <td width="142" bgcolor="#FFFFFF" class="normaltext" valign="top"><strong>Include Name: </strong></td>
      <td width="569" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="iname"
      size="41"> (Choose a Name)<br>
      Only Alphabetical and Numerical Characters Allowed </td>
    </tr>
    <tr>
      <td width="142" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Include Type: </strong></td>
      <td width="569" bgcolor="#FFFFFF" class="normaltext"><select name="itype" size="1">
        <option value="New"> New </option>
        <option value="Popular"> Popular </option>
      </select> <br>
      <strong>&nbsp;&nbsp; <br>
      New: </strong>List new links <br>
      <strong>Popular: </strong>List links with the most clicks </td>
    </tr>
    <tr>
      <td width="142" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Premium Links
      Only:</strong></td>
      <td width="569" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="prem"
      value="Y">(If this is checked then only 'premium' new or 'premium' popular links will be
      included)</td>
    </tr>
    <tr>
      <td width="142" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Category ID: </strong></td>
      <td width="569" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="crosslinkid"
      size="5"> <strong>(<a href="$admin_url/admin67.cgi"
      onClick="popup('$admin_url/admin67.cgi',750,600);return false;">Browser</a>)</strong><br>
      Please specify a category ID above. Click the 'Browser' link to find a category.<br>
      Specify a <strong>value of 0</strong> if you want to compile Popular or New links from all
      categories. </td>
    </tr>
    <tr>
      <td width="142" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Popularity: </strong></td>
      <td width="569" bgcolor="#FFFFFF" class="normaltext"><select name="sort" size="1">
        <option value="vote"> Most Voted </option>
        <option value="click"> Most Clicked </option>
      </select> <br>
      &nbsp;&nbsp; <br>
      <strong>Most voted: </strong>Display links with the most votes <br>
      <strong>Most Clicked: </strong>Display links with the most clicks <p>This setting is only
      valid if this include will display popular links. </td>
    </tr>
    <tr>
      <td width="142" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Number of Links:
      </strong></td>
      <td width="569" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="inumber"
      size="5"> <br>
      The number of popular or new links to be displayed. </td>
    </tr>
    <tr>
      <td width="142" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Link Template: </strong></td>
      <td width="569" bgcolor="#FFFFFF" class="normaltext"><textarea rows="16" name="template"
      cols="75" style="width:100%">$linkstyle</textarea> <br>
      <a href="$admin_url/admin6.cgi?template=tmplsearch&amp;fct=tinfo" target="_blank">Click
      here </a>to see what PowerSeek variables can be used. This template represents the style
      of the links that will be displayed in the include. It functions in the same way the
      PowerSeek link style template does. (tmplsearch.html) </td>
    </tr>
    <tr>
      <td width="142" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="569" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="   Add Link Include   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
  <p>$helpb </p>
</form>

</body>
</html>

END_OF_ADD_I



}





sub start
{

$incls = acs::get_file_contents("$data_dir/tmpl_inc.dat"); 
@all_inc = split (/\n/, $incls);

$inr = @all_inc;


if ($inr > 0)
{
## GET CATEGORIES
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
}


$cnt = 0;
foreach $item (@all_inc)
	{
	($i_iname, $i_itype, $i_cid, $i_isort, $i_inumber, $i_prem) = split (/\t/, $item);

	if ($i_isort eq "vote") { $i_isort = "Votes"; } else { $i_isort = "Clicks"; }

	$lastcat = "";
	
if ($i_cid != 0)
{

### GET CATEGORY
$sql = "SELECT * FROM dirs WHERE cid = '$i_cid'";
$sth = $dbh->prepare($sql); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$cnt = 0;
while ( @row = $sth->fetchrow() )
	{ 
	$ecat = "";
	$lv = 0;
	for ($ms = 2; $ms < 18; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$ecat = $ecat . acs::encode_dir($row[$ms]) . "-";
			$lastcat = $row[$ms];
			$lv++;
			}
		}
		$ecat = substr($ecat, 0, length($ecat) - 1);
	} 

$lastcat = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\" target=\"_blank\">$lastcat</a>";

}
else
{
$lastcat = "Root";
}
########

if ($i_itype eq "New")
	{
	$i_isort = "N/A";
	}

$premdisp = "";
if ($i_prem eq "Y") { $premdisp = "Premium<BR>"; } 
	
$includes = $includes . <<END_OF_INCLUDES;
  <tr>
    <td width="20%" bgcolor="#FFFFFF" class="normaltext"><b>$i_iname </b></td>
    <td width="5%" bgcolor="#FFFFFF" class="normaltext" align="center">$premdisp $i_itype </td>
    <td width="5%" bgcolor="#FFFFFF" class="normaltext" align="center">$i_isort </td>
    <td width="5%" bgcolor="#FFFFFF" class="normaltext" align="center">$i_inumber </td>
    <td width="30%" bgcolor="#FFFFFF" class="normaltext">$lastcat </td>
    <td width="15%" bgcolor="#FFFFFF" class="normaltext" align="center"><a
    href="$admin_url/admin45.cgi?fct=edit&amp;iname=$i_iname">Edit </a>| <a
    href="$admin_url/admin45.cgi?fct=delete&amp;iname=$i_iname">Delete</a></td>
    <td width="15%" bgcolor="#FFFFFF" class="normaltext"><p align="center"><a
    href="$admin_url/admin45.cgi?fct=get_html&amp;iname=$i_iname">Generate <br>
    Get HTML </a></td>
    <td width="5%" bgcolor="#FFFFFF" class="normaltext"><a
    href="$admin_url/admin45.cgi?fct=preview&amp;iname=$i_iname" target="_blank">Preview </a></td>
  </tr>
END_OF_INCLUDES
	}


if (($inr > 0) and ($sql ne ""))
{
$sth->finish;
$dbh->disconnect; 
}


if ($inr < 1)
{
$includes = <<END_OF_NOTHING;
<td bgcolor="#FFFFFF" width="20%" colspan="8"><font face="Verdana" size="1"><b>No Includes Created Yet.</b></font></td>
END_OF_NOTHING
}


$hbox = acs::get_heading_box("$web_url/ic_pop2.gif", "Popular & New Link Includes", qq[
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="89%" valign="top" class="normaltext">Enables you to create link pages that contain the most
    popular and/or new links for specified categories. You can include these link pages via
    'JavaScript Includes' into other existing pages or PowerSeek templates. </td>
    <td width="6%" valign="top" align="right"><font face="Arial" size="4" color="#000000"><strong><a
    href="$admin_url/help.cgi?fct=newpop" target="_blank"><img src="$web_url/bhelps.gif"
    border="0"></a></strong></font></td>
  </tr>
</table>
]);



$helpb = acs::quick_help("Help",qq[
<p><strong>Option Descriptions:</strong></p>

<blockquote>
  <p><strong>Include Name: </strong>The name of the include <br>
  &nbsp; <br>
  <strong>Type:</strong></p>
  <blockquote>
    <p><strong>Popular: </strong>Lists the most clicked or popular links from a specified
    category. <br>
    <strong>New:</strong> Lists the most recent links from a specified category. </p>
  </blockquote>
  <p><strong>Sorting: </strong>Only applicable to popular Links Includes. Sort popular links
  by most votes or most clicks. <br>
  <strong>&nbsp; <br>
  Number: </strong>Number of new or popular links displayed in the include. <br>
  <strong>&nbsp;&nbsp; <br>
  Category: </strong>The category where new links and popular links are filtered from <br>
  <strong>&nbsp;&nbsp; <br>
  Edit / Delete: </strong>Edit or Delete the Link Include. <br>
  <strong>&nbsp; <br>
  Get HTML: </strong>Generate the HTML include and get the HTML code to place inside
  PowerSeek templates or external web pages. <br>
  <strong>&nbsp;&nbsp; <br>
  Preview: </strong>Preview the Link Include. (How it will look like when included in a
  PowerSeek template or external web page) </p>
</blockquote>

<p><strong>Notes:</strong></p>

<blockquote>
  <p>Let's say that you would like to display the most popular or new links from a main
  category called 'Business' for example. To list the most popular links on an external web
  page or in any PowerSeek templates, create a <strong>Link Include </strong>and copy and
  paste the HTML code for it into an external Web Page or PowerSeek template. Once the code
  is in the web page or template the most popular links from the Business category will be
  displayed on the web page or in the PowerSeek template. Note that for <strong>Link
  Includes</strong> to be displayed that you will have to rebuild your HTML files because
  the new and popular link includes are generated when generating HTML files. You can also
  generate the link include files here by clicking on 'Generate' above. </p>
</blockquote>
]);  



print <<END_OF_START;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox



<form method="POST" action="$admin_url/admin45.cgi">
  <input type="hidden" name="fct" value="add_include"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#D2D2D2">
    <tr>
      <td width="781" height="30" colspan="8" background="$web_url/bar6.gif" bgcolor="#FFFFFF"
      class="normaltext"><strong>Hot &amp; New Link Includes </strong></td>
    </tr>
<tr>
    <td width="20%" height="30" bgcolor="#F8F8F8" class="normaltext"><strong>Include Name </strong></td>
    <td width="5%" bgcolor="#F8F8F8" class="normaltext" align="center"><strong>Type </strong></td>
    <td width="5%" bgcolor="#F8F8F8" class="normaltext" align="center"><strong>Sorting </strong></td>
    <td width="5%" bgcolor="#F8F8F8" class="normaltext" align="center"><strong>Number </strong></td>
    <td width="30%" bgcolor="#F8F8F8" class="normaltext"><strong>Category </strong></td>
    <td width="15%" bgcolor="#F8F8F8" class="normaltext" align="center"><strong>Edit / Delete </strong></td>
    <td width="15%" align="center" bgcolor="#F8F8F8" class="normaltext"><strong>Get HTML </strong></td>
    <td width="5%" bgcolor="#F8F8F8" class="normaltext"><strong>Preview </strong></td>
  </tr>
$includes
    <tr>
      <td width="781" colspan="8" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="   Add Link Include   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

$helpb

</body>
</html>

END_OF_START

}


####################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

